%bcond_without check

Summary: Transform Linux Audit logs for SIEM usage 
Name: laurel
Version: 0.6.2
Release: 1%{?dist}
License: GPL3
URL: https://github.com/threathunters-io/laurel
Source0: laurel-0.6.2.tar.gz
Source1: vendor.tar.gz
Source2: laurel.conf
Source3: config.toml
BuildRequires: cargo-rpm-macros >= 26
BuildRequires: clang libacl-devel
# man pages
BuildRequires: pandoc make
# SELinux
BuildRequires: selinux-policy-devel

%description
LAUREL is an event post-processing plugin for auditd(8) that generates useful, 
enriched JSON-based audit logs suitable for modern security monitoring setups.

%package selinux
Summary: SELinux policy module supporting %{name}
Requires: %{name} >= %{version}-%{release}
Requires(post): policycoreutils-python-utils
Requires(postun): policycoreutils-python-utils

%description selinux
SELinux policy module supporting %{name}

%prep

%setup -q -a1
%cargo_prep

# to download the deps, type "cargo vendor" and make a tar ball of the vendor directory

# some weird shit here
sed -i "s|^registry.*||g" .cargo/config.toml
sed -i "s|^replace-with.*|replace-with = \"vendored-sources\"|g" .cargo/config.toml

cat >> .cargo/config.toml << EOF
 
[source.vendored-sources]
directory = "vendor"
EOF

cat >> Cargo.toml << EOF
[profile.release]
lto = true
EOF

%build
export RUSTFLAGS="%build_rustflags"

%cargo_build

# man pages
make -C man

# SElinux
cp -rp contrib/selinux selinux
cd selinux
for selinuxvariant in mls targeted; do
    make NAME=${selinuxvariant} -f %{_datadir}/selinux/devel/Makefile
    mv %{name}.pp %{name}.pp.${selinuxvariant}
    make NAME=${selinuxvariant} -f %{_datadir}/selinux/devel/Makefile clean
done
cd -

%install
install -d %{buildroot}%{_sysconfdir}/audit/plugins.d
install -d %{buildroot}%{_sysconfdir}/laurel
install -d %{buildroot}%{_localstatedir}/log/laurel
install -m0644 %{SOURCE2} %{buildroot}%{_sysconfdir}/audit/plugins.d/laurel.conf
install -m0644 %{SOURCE3} %{buildroot}%{_sysconfdir}/laurel/config.toml

install -d %{buildroot}%{_sbindir}
install -m0755 target/rpm/laurel %{buildroot}%{_sbindir}/
install -m0755 target/rpm/laurel2audit %{buildroot}%{_sbindir}/

install -d %{buildroot}%{_mandir}/man{7,8}
install -m0644 man/*.7 %{buildroot}%{_mandir}/man7/
install -m0644 man/*.8 %{buildroot}%{_mandir}/man8/

cd selinux
for selinuxvariant in mls targeted; do
    install -d %{buildroot}%{_datadir}/selinux/${selinuxvariant}
    install -p -m 644 %{name}.pp.${selinuxvariant} %{buildroot}%{_datadir}/selinux/${selinuxvariant}/%{name}.pp
done
cd -

%if %{with check}
%check
%cargo_test
%endif

%post selinux
for selinuxvariant in mls targeted; do
    %{_sbindir}/semodule -s ${selinuxvariant} -i %{_datadir}/selinux/${selinuxvariant}/%{name}.pp &> /dev/null || :
done

%postun selinux
if [ $1 -eq 0 ] ; then
    for selinuxvariant in mls targeted; do
	%{_sbindir}/semodule -s ${selinuxvariant} -r %{name} &> /dev/null || :
    done
fi

%files
%doc LICENSE README* audit-specs
%config(noreplace) %{_sysconfdir}/audit/plugins.d/laurel.conf
%config(noreplace) %{_sysconfdir}/laurel/config.toml
%{_sbindir}/laurel
%{_sbindir}/laurel2audit
%{_mandir}/man7/*
%{_mandir}/man8/*
%dir %{_localstatedir}/log/laurel

%files selinux
%doc contrib/selinux/*
%{_datadir}/selinux/*/%{name}.pp

%changelog
* Sun Jun 16 2024 Oden Eriksson <oe@nux.se> - 0.6.2-1
- rebuild for RHEL 9 and FC40

* Fri Jun 14 2024 Oden Eriksson <oe@nux.se> - 0.6.2-0.2
- added some of the fedora guidelines

* Thu Jun 13 2024 Oden Eriksson <oe@nux.se> - 0.6.2-0.1
- first blood
